Package org.springframework.web.filter

# Class OncePerRequestFilter

java.lang.Object
org.springframework.web.filter.GenericFilterBean
org.springframework.web.filter.OncePerRequestFilter

All Implemented Interfaces:
  `Filter`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.context.EnvironmentAware`, `org.springframework.core.env.EnvironmentCapable`, `ServletContextAware`

Direct Known Subclasses:
  `AbstractRequestLoggingFilter`, `CharacterEncodingFilter`, `CorsFilter`, `FormContentFilter`, `ForwardedHeaderFilter`, `HiddenHttpMethodFilter`, `MultipartFilter`, `RelativeRedirectFilter`, `RequestContextFilter`, `ServerHttpObservationFilter`, `ShallowEtagHeaderFilter`, `UrlHandlerFilter`

public abstract class OncePerRequestFilter extends GenericFilterBean
Filter base class that aims to guarantee a single execution per request dispatch, on any servlet container. It provides a `doFilterInternal(jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse, jakarta.servlet.FilterChain)` method with HttpServletRequest and HttpServletResponse arguments.

A filter may be invoked as part of a `REQUEST` or `ASYNC` dispatches that occur in separate threads. A filter can be configured in `web.xml` whether it should be involved in async dispatches. However, in some cases servlet containers assume different default configuration. Therefore, subclasses can override the method `shouldNotFilterAsyncDispatch()` to declare statically if they should indeed be invoked, once, during both types of dispatches in order to provide thread initialization, logging, security, and so on. This mechanism complements and does not replace the need to configure a filter in `web.xml` with dispatcher types.

Subclasses may use `isAsyncDispatch(HttpServletRequest)` to determine when a filter is invoked as part of an async dispatch, and use `isAsyncStarted(HttpServletRequest)` to determine when the request has been placed in async mode and therefore the current dispatch won't be the last one for the given request.

Yet another dispatch type that also occurs in its own thread is `ERROR`. Subclasses can override `shouldNotFilterErrorDispatch()` if they wish to declare statically if they should be invoked once during error dispatches.

The `getAlreadyFilteredAttributeName()` method determines how to identify that a request is already filtered. The default implementation is based on the configured name of the concrete filter instance.

Since:
  06.12.2003
Author:
  Juergen Hoeller, Rossen Stoyanchev, Sam Brannen

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ALREADY_FILTERED_SUFFIX`
Suffix that gets appended to the filter name for the "already filtered" request attribute.

### Fields inherited from class org.springframework.web.filter.GenericFilterBean

`logger`

## Constructor Summary

Constructors
Constructor
Description
`OncePerRequestFilter()`

## Method Summary

Modifier and Type
Method
Description
`final void`
`doFilter(ServletRequest request, ServletResponse response, FilterChain filterChain)`
This `doFilter` implementation stores a request attribute for "already filtered", proceeding without filtering again if the attribute is already there.
`protected abstract void`
`doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)`
Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread.
`protected void`
`doFilterNestedErrorDispatch(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)`
Typically an ERROR dispatch happens after the REQUEST dispatch completes, and the filter chain starts anew.
`protected String`
`getAlreadyFilteredAttributeName()`
Return the name of the request attribute that identifies that a request is already filtered.
`protected boolean`
`isAsyncDispatch(HttpServletRequest request)`
The dispatcher type `jakarta.servlet.DispatcherType.ASYNC` means a filter can be invoked in more than one thread over the course of a single request.
`protected boolean`
`isAsyncStarted(HttpServletRequest request)`
Whether request processing is in asynchronous mode meaning that the response will not be committed after the current thread is exited.
`protected boolean`
`shouldNotFilter(HttpServletRequest request)`
Can be overridden in subclasses for custom filtering control, returning `true` to avoid filtering of the given request.
`protected boolean`
`shouldNotFilterAsyncDispatch()`
The dispatcher type `jakarta.servlet.DispatcherType.ASYNC` means a filter can be invoked in more than one thread over the course of a single request.
`protected boolean`
`shouldNotFilterErrorDispatch()`
Whether to filter error dispatches such as when the servlet container processes and error mapped in `web.xml`.

### Methods inherited from class org.springframework.web.filter.GenericFilterBean

`addRequiredProperty, afterPropertiesSet, createEnvironment, destroy, getEnvironment, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### ALREADY_FILTERED_SUFFIX

public static final String ALREADY_FILTERED_SUFFIX
Suffix that gets appended to the filter name for the "already filtered" request attribute.

See Also:
  - `getAlreadyFilteredAttributeName()`
  - Constant Field Values

## Constructor Details

### OncePerRequestFilter

public OncePerRequestFilter()

## Method Details

### doFilter

public final void doFilter(ServletRequest request, ServletResponse response, FilterChain filterChain) throws ServletException, IOException
This `doFilter` implementation stores a request attribute for "already filtered", proceeding without filtering again if the attribute is already there.

Throws:
  `ServletException`
  `IOException`
See Also:
  - `getAlreadyFilteredAttributeName()`
  - `shouldNotFilter(jakarta.servlet.http.HttpServletRequest)`
  - `doFilterInternal(jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse, jakarta.servlet.FilterChain)`

### isAsyncDispatch

protected boolean isAsyncDispatch(HttpServletRequest request)
The dispatcher type `jakarta.servlet.DispatcherType.ASYNC` means a filter can be invoked in more than one thread over the course of a single request. This method returns `true` if the filter is currently executing within an asynchronous dispatch.

Parameters:
  `request` - the current request
Since:
  3.2
See Also:
  - `WebAsyncManager.hasConcurrentResult()`

### isAsyncStarted

protected boolean isAsyncStarted(HttpServletRequest request)
Whether request processing is in asynchronous mode meaning that the response will not be committed after the current thread is exited.

Parameters:
  `request` - the current request
Since:
  3.2
See Also:
  - `WebAsyncManager.isConcurrentHandlingStarted()`

### getAlreadyFilteredAttributeName

protected String getAlreadyFilteredAttributeName()
Return the name of the request attribute that identifies that a request is already filtered.

The default implementation takes the configured name of the concrete filter instance and appends ".FILTERED". If the filter is not fully initialized, it falls back to its class name.

See Also:
  - `GenericFilterBean.getFilterName()`
  - `ALREADY_FILTERED_SUFFIX`

### shouldNotFilter

protected boolean shouldNotFilter(HttpServletRequest request) throws ServletException
Can be overridden in subclasses for custom filtering control, returning `true` to avoid filtering of the given request.

The default implementation always returns `false`.

Parameters:
  `request` - current HTTP request
Returns:
  whether the given request should not be filtered
Throws:
  `ServletException` - in case of errors

### shouldNotFilterAsyncDispatch

protected boolean shouldNotFilterAsyncDispatch()
The dispatcher type `jakarta.servlet.DispatcherType.ASYNC` means a filter can be invoked in more than one thread over the course of a single request. Some filters only need to filter the initial thread (for example, request wrapping) while others may need to be invoked at least once in each additional thread for example for setting up thread locals or to perform final processing at the very end.

Note that although a filter can be mapped to handle specific dispatcher types via `web.xml` or in Java through the `ServletContext`, servlet containers may enforce different defaults with respect to dispatcher types. This flag enforces the design intent of the filter.

The default return value is "true", which means the filter will not be invoked during subsequent async dispatches. If "false", the filter will be invoked during async dispatches with the same guarantees of being invoked only once during a request within a single thread.

Since:
  3.2

### shouldNotFilterErrorDispatch

protected boolean shouldNotFilterErrorDispatch()
Whether to filter error dispatches such as when the servlet container processes and error mapped in `web.xml`. The default return value is "true", which means the filter will not be invoked in case of an error dispatch.

Since:
  3.2

### doFilterInternal

protected abstract void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException
Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread. See `shouldNotFilterAsyncDispatch()` for details.

Provides HttpServletRequest and HttpServletResponse arguments instead of the default ServletRequest and ServletResponse ones.

Throws:
  `ServletException`
  `IOException`

### doFilterNestedErrorDispatch

protected void doFilterNestedErrorDispatch(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException
Typically an ERROR dispatch happens after the REQUEST dispatch completes, and the filter chain starts anew. On some servers however the ERROR dispatch may be nested within the REQUEST dispatch, for example, as a result of calling `sendError` on the response. In that case we are still in the filter chain, on the same thread, but the request and response have been switched to the original, unwrapped ones.

Sub-classes may use this method to filter such nested ERROR dispatches and re-apply wrapping on the request or response. `ThreadLocal` context, if any, should still be active as we are still nested within the filter chain.

Throws:
  `ServletException`
  `IOException`
Since:
  5.1.9